//LEDs管脚定义
int leds[8] = {6, 7, 8, 9, 10, 11, 12, 13};
int gnds[8] = {2, 3, 4, 5, 14, 15, 16, 17};

int table1[8][8] =                         //大“心型”的数据
{
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 1, 1, 0, 0, 1, 1, 0,
  1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1,
  0, 1, 1, 1, 1, 1, 1, 0,
  0, 0, 1, 1, 1, 1, 0, 0,
  0, 0, 0, 1, 1, 0, 0, 0,
};

int table2[8][8] =                         //小“心型”的数据
{
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 1, 0, 0, 1, 0, 0,
  0, 1, 1, 1, 1, 1, 1, 0,
  0, 1, 1, 1, 1, 1, 1, 0,
  0, 0, 1, 1, 1, 1, 0, 0,
  0, 0, 0, 1, 1, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
};

void setup() {
  // put your setup code here, to run once:
  for (int i = 0; i < 8; i++)
  {
    pinMode(leds[i], OUTPUT);
    pinMode(gnds[i], OUTPUT);
    digitalWrite(gnds[i], HIGH);
  }
}

void ledopen()
{
  for (int i = 0; i < 8; i++)
  {
    digitalWrite(leds[i], HIGH);
    digitalWrite(gnds[i], LOW);
  }
}

void ledclean()
{
  for (int i = 0; i < 8; i++)
  {
    digitalWrite(leds[i], LOW);
    digitalWrite(gnds[i], HIGH);
  }
}

void ledCol()
{
  for (int i = 0 ; i < 8; i++)
  {
    digitalWrite(gnds[i], LOW);
    for (int j = 0; j < 8; j++)
    {
      digitalWrite(leds[j], HIGH);
      delayMicroseconds(100);
    }
    digitalWrite(gnds[i], HIGH);
    ledclean();
  }
}

void ledRow()
{
  for (int i = 0 ; i < 8; i++)
  {
    digitalWrite(leds[i], HIGH);
    for (int j = 0; j < 8; j++)
    {
      digitalWrite(gnds[j], LOW);
      delayMicroseconds(100);
    }
    digitalWrite(leds[i], LOW);
    ledclean();
  }
}

void ledShow(int temp[8][8])
{
  for (int j = 0 ; j < 8; j++)
  {
    digitalWrite(gnds[j], LOW);
    for (int i = 0; i < 8; i++)
    {
      digitalWrite(leds[i], temp[i][j]);
      delayMicroseconds(100);
    }
    digitalWrite(gnds[j], HIGH);
    ledclean();
  }
}


void loop() {
  // put your main code here, to run repeatedly:
  //  ledopen(); //全部打开
  //  delay(500);
  //  ledclean(); //全部关闭
  //  delay(500);
  //ledCol(); //列扫描
  //ledRow(); //行扫描

  for (int i = 0; i < 100; i++) //利用for循环达到刷新延时的效果
  {
    ledShow(table1);
  }
  for (int i = 0; i < 50; i++)//利用for循环达到刷新延时的效果
  {
    ledShow(table2);
  }


}












